package erdiagram.diagram.part;

import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.gmf.tooling.runtime.update.DiagramUpdater;

import edu.toronto.cs.se.modelepedia.erdiagram.ERDiagram;
import edu.toronto.cs.se.modelepedia.erdiagram.Entity;
import edu.toronto.cs.se.modelepedia.erdiagram.ErdiagramPackage;
import edu.toronto.cs.se.modelepedia.erdiagram.Relationship;
import erdiagram.diagram.edit.parts.ERDiagramEditPart;
import erdiagram.diagram.edit.parts.EntityEditPart;
import erdiagram.diagram.edit.parts.RelationshipEditPart;
import erdiagram.diagram.edit.parts.RelationshipFromEditPart;
import erdiagram.diagram.edit.parts.RelationshipToEditPart;
import erdiagram.diagram.providers.ErdiagramElementTypes;

/**
 * @generated
 */
public class ErdiagramDiagramUpdater {

	/**
	 * @generated
	 */
	public static List<ErdiagramNodeDescriptor> getSemanticChildren(View view) {
		switch (ErdiagramVisualIDRegistry.getVisualID(view)) {
		case ERDiagramEditPart.VISUAL_ID:
			return getERDiagram_1000SemanticChildren(view);
		}
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<ErdiagramNodeDescriptor> getERDiagram_1000SemanticChildren(
			View view) {
		if (!view.isSetElement()) {
			return Collections.emptyList();
		}
		ERDiagram modelElement = (ERDiagram) view.getElement();
		LinkedList<ErdiagramNodeDescriptor> result = new LinkedList<ErdiagramNodeDescriptor>();
		for (Iterator<?> it = modelElement.getRelationships().iterator(); it
				.hasNext();) {
			Relationship childElement = (Relationship) it.next();
			int visualID = ErdiagramVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == RelationshipEditPart.VISUAL_ID) {
				result.add(new ErdiagramNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator<?> it = modelElement.getEntities().iterator(); it
				.hasNext();) {
			Entity childElement = (Entity) it.next();
			int visualID = ErdiagramVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == EntityEditPart.VISUAL_ID) {
				result.add(new ErdiagramNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List<ErdiagramLinkDescriptor> getContainedLinks(View view) {
		switch (ErdiagramVisualIDRegistry.getVisualID(view)) {
		case ERDiagramEditPart.VISUAL_ID:
			return getERDiagram_1000ContainedLinks(view);
		case RelationshipEditPart.VISUAL_ID:
			return getRelationship_2001ContainedLinks(view);
		case EntityEditPart.VISUAL_ID:
			return getEntity_2002ContainedLinks(view);
		}
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<ErdiagramLinkDescriptor> getIncomingLinks(View view) {
		switch (ErdiagramVisualIDRegistry.getVisualID(view)) {
		case RelationshipEditPart.VISUAL_ID:
			return getRelationship_2001IncomingLinks(view);
		case EntityEditPart.VISUAL_ID:
			return getEntity_2002IncomingLinks(view);
		}
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<ErdiagramLinkDescriptor> getOutgoingLinks(View view) {
		switch (ErdiagramVisualIDRegistry.getVisualID(view)) {
		case RelationshipEditPart.VISUAL_ID:
			return getRelationship_2001OutgoingLinks(view);
		case EntityEditPart.VISUAL_ID:
			return getEntity_2002OutgoingLinks(view);
		}
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<ErdiagramLinkDescriptor> getERDiagram_1000ContainedLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<ErdiagramLinkDescriptor> getRelationship_2001ContainedLinks(
			View view) {
		Relationship modelElement = (Relationship) view.getElement();
		LinkedList<ErdiagramLinkDescriptor> result = new LinkedList<ErdiagramLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_Relationship_To_4002(modelElement));
		result.addAll(getOutgoingFeatureModelFacetLinks_Relationship_From_4001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<ErdiagramLinkDescriptor> getEntity_2002ContainedLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<ErdiagramLinkDescriptor> getRelationship_2001IncomingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<ErdiagramLinkDescriptor> getEntity_2002IncomingLinks(
			View view) {
		Entity modelElement = (Entity) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<ErdiagramLinkDescriptor> result = new LinkedList<ErdiagramLinkDescriptor>();
		result.addAll(getIncomingFeatureModelFacetLinks_Relationship_To_4002(
				modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Relationship_From_4001(
				modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<ErdiagramLinkDescriptor> getRelationship_2001OutgoingLinks(
			View view) {
		Relationship modelElement = (Relationship) view.getElement();
		LinkedList<ErdiagramLinkDescriptor> result = new LinkedList<ErdiagramLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_Relationship_To_4002(modelElement));
		result.addAll(getOutgoingFeatureModelFacetLinks_Relationship_From_4001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<ErdiagramLinkDescriptor> getEntity_2002OutgoingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	private static Collection<ErdiagramLinkDescriptor> getIncomingFeatureModelFacetLinks_Relationship_To_4002(
			Entity target,
			Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences) {
		LinkedList<ErdiagramLinkDescriptor> result = new LinkedList<ErdiagramLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences
				.get(target);
		for (EStructuralFeature.Setting setting : settings) {
			if (setting.getEStructuralFeature() == ErdiagramPackage.eINSTANCE
					.getRelationship_To()) {
				result.add(new ErdiagramLinkDescriptor(setting.getEObject(),
						target, ErdiagramElementTypes.RelationshipTo_4002,
						RelationshipToEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<ErdiagramLinkDescriptor> getIncomingFeatureModelFacetLinks_Relationship_From_4001(
			Entity target,
			Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences) {
		LinkedList<ErdiagramLinkDescriptor> result = new LinkedList<ErdiagramLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences
				.get(target);
		for (EStructuralFeature.Setting setting : settings) {
			if (setting.getEStructuralFeature() == ErdiagramPackage.eINSTANCE
					.getRelationship_From()) {
				result.add(new ErdiagramLinkDescriptor(setting.getEObject(),
						target, ErdiagramElementTypes.RelationshipFrom_4001,
						RelationshipFromEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<ErdiagramLinkDescriptor> getOutgoingFeatureModelFacetLinks_Relationship_To_4002(
			Relationship source) {
		LinkedList<ErdiagramLinkDescriptor> result = new LinkedList<ErdiagramLinkDescriptor>();
		Entity destination = source.getTo();
		if (destination == null) {
			return result;
		}
		result.add(new ErdiagramLinkDescriptor(source, destination,
				ErdiagramElementTypes.RelationshipTo_4002,
				RelationshipToEditPart.VISUAL_ID));
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<ErdiagramLinkDescriptor> getOutgoingFeatureModelFacetLinks_Relationship_From_4001(
			Relationship source) {
		LinkedList<ErdiagramLinkDescriptor> result = new LinkedList<ErdiagramLinkDescriptor>();
		Entity destination = source.getFrom();
		if (destination == null) {
			return result;
		}
		result.add(new ErdiagramLinkDescriptor(source, destination,
				ErdiagramElementTypes.RelationshipFrom_4001,
				RelationshipFromEditPart.VISUAL_ID));
		return result;
	}

	/**
	 * @generated
	 */
	public static final DiagramUpdater TYPED_INSTANCE = new DiagramUpdater() {
		/**
		 * @generated
		 */
		@Override
		public List<ErdiagramNodeDescriptor> getSemanticChildren(View view) {
			return ErdiagramDiagramUpdater.getSemanticChildren(view);
		}

		/**
		 * @generated
		 */
		@Override
		public List<ErdiagramLinkDescriptor> getContainedLinks(View view) {
			return ErdiagramDiagramUpdater.getContainedLinks(view);
		}

		/**
		 * @generated
		 */
		@Override
		public List<ErdiagramLinkDescriptor> getIncomingLinks(View view) {
			return ErdiagramDiagramUpdater.getIncomingLinks(view);
		}

		/**
		 * @generated
		 */
		@Override
		public List<ErdiagramLinkDescriptor> getOutgoingLinks(View view) {
			return ErdiagramDiagramUpdater.getOutgoingLinks(view);
		}
	};

}
