package erdiagram.diagram.providers;

import java.util.HashSet;
import java.util.IdentityHashMap;
import java.util.Map;
import java.util.Set;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.ENamedElement;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.gmf.runtime.emf.type.core.ElementTypeRegistry;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.swt.graphics.Image;

import edu.toronto.cs.se.modelepedia.erdiagram.ErdiagramPackage;
import erdiagram.diagram.edit.parts.ERDiagramEditPart;
import erdiagram.diagram.edit.parts.EntityEditPart;
import erdiagram.diagram.edit.parts.RelationshipEditPart;
import erdiagram.diagram.edit.parts.RelationshipFromEditPart;
import erdiagram.diagram.edit.parts.RelationshipToEditPart;
import erdiagram.diagram.part.ErdiagramDiagramEditorPlugin;

/**
 * @generated
 */
public class ErdiagramElementTypes {

	/**
	 * @generated
	 */
	private ErdiagramElementTypes() {
	}

	/**
	 * @generated
	 */
	private static Map<IElementType, ENamedElement> elements;

	/**
	 * @generated
	 */
	private static ImageRegistry imageRegistry;

	/**
	 * @generated
	 */
	private static Set<IElementType> KNOWN_ELEMENT_TYPES;

	/**
	 * @generated
	 */
	public static final IElementType ERDiagram_1000 = getElementType("edu.toronto.cs.se.modelepedia.erdiagram.diagram.ERDiagram_1000"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Relationship_2001 = getElementType("edu.toronto.cs.se.modelepedia.erdiagram.diagram.Relationship_2001"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Entity_2002 = getElementType("edu.toronto.cs.se.modelepedia.erdiagram.diagram.Entity_2002"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType RelationshipTo_4002 = getElementType("edu.toronto.cs.se.modelepedia.erdiagram.diagram.RelationshipTo_4002"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType RelationshipFrom_4001 = getElementType("edu.toronto.cs.se.modelepedia.erdiagram.diagram.RelationshipFrom_4001"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	private static ImageRegistry getImageRegistry() {
		if (imageRegistry == null) {
			imageRegistry = new ImageRegistry();
		}
		return imageRegistry;
	}

	/**
	 * @generated
	 */
	private static String getImageRegistryKey(ENamedElement element) {
		return element.getName();
	}

	/**
	 * @generated
	 */
	private static ImageDescriptor getProvidedImageDescriptor(
			ENamedElement element) {
		if (element instanceof EStructuralFeature) {
			EStructuralFeature feature = ((EStructuralFeature) element);
			EClass eContainingClass = feature.getEContainingClass();
			EClassifier eType = feature.getEType();
			if (eContainingClass != null && !eContainingClass.isAbstract()) {
				element = eContainingClass;
			} else if (eType instanceof EClass
					&& !((EClass) eType).isAbstract()) {
				element = eType;
			}
		}
		if (element instanceof EClass) {
			EClass eClass = (EClass) element;
			if (!eClass.isAbstract()) {
				return ErdiagramDiagramEditorPlugin.getInstance()
						.getItemImageDescriptor(
								eClass.getEPackage().getEFactoryInstance()
										.create(eClass));
			}
		}
		// TODO : support structural features
		return null;
	}

	/**
	 * @generated
	 */
	public static ImageDescriptor getImageDescriptor(ENamedElement element) {
		String key = getImageRegistryKey(element);
		ImageDescriptor imageDescriptor = getImageRegistry().getDescriptor(key);
		if (imageDescriptor == null) {
			imageDescriptor = getProvidedImageDescriptor(element);
			if (imageDescriptor == null) {
				imageDescriptor = ImageDescriptor.getMissingImageDescriptor();
			}
			getImageRegistry().put(key, imageDescriptor);
		}
		return imageDescriptor;
	}

	/**
	 * @generated
	 */
	public static Image getImage(ENamedElement element) {
		String key = getImageRegistryKey(element);
		Image image = getImageRegistry().get(key);
		if (image == null) {
			ImageDescriptor imageDescriptor = getProvidedImageDescriptor(element);
			if (imageDescriptor == null) {
				imageDescriptor = ImageDescriptor.getMissingImageDescriptor();
			}
			getImageRegistry().put(key, imageDescriptor);
			image = getImageRegistry().get(key);
		}
		return image;
	}

	/**
	 * @generated
	 */
	public static ImageDescriptor getImageDescriptor(IAdaptable hint) {
		ENamedElement element = getElement(hint);
		if (element == null) {
			return null;
		}
		return getImageDescriptor(element);
	}

	/**
	 * @generated
	 */
	public static Image getImage(IAdaptable hint) {
		ENamedElement element = getElement(hint);
		if (element == null) {
			return null;
		}
		return getImage(element);
	}

	/**
	 * Returns 'type' of the ecore object associated with the hint.
	 * 
	 * @generated
	 */
	public static ENamedElement getElement(IAdaptable hint) {
		Object type = hint.getAdapter(IElementType.class);
		if (elements == null) {
			elements = new IdentityHashMap<IElementType, ENamedElement>();

			elements.put(ERDiagram_1000,
					ErdiagramPackage.eINSTANCE.getERDiagram());

			elements.put(Relationship_2001,
					ErdiagramPackage.eINSTANCE.getRelationship());

			elements.put(Entity_2002, ErdiagramPackage.eINSTANCE.getEntity());

			elements.put(RelationshipTo_4002,
					ErdiagramPackage.eINSTANCE.getRelationship_To());

			elements.put(RelationshipFrom_4001,
					ErdiagramPackage.eINSTANCE.getRelationship_From());
		}
		return (ENamedElement) elements.get(type);
	}

	/**
	 * @generated
	 */
	private static IElementType getElementType(String id) {
		return ElementTypeRegistry.getInstance().getType(id);
	}

	/**
	 * @generated
	 */
	public static boolean isKnownElementType(IElementType elementType) {
		if (KNOWN_ELEMENT_TYPES == null) {
			KNOWN_ELEMENT_TYPES = new HashSet<IElementType>();
			KNOWN_ELEMENT_TYPES.add(ERDiagram_1000);
			KNOWN_ELEMENT_TYPES.add(Relationship_2001);
			KNOWN_ELEMENT_TYPES.add(Entity_2002);
			KNOWN_ELEMENT_TYPES.add(RelationshipTo_4002);
			KNOWN_ELEMENT_TYPES.add(RelationshipFrom_4001);
		}
		return KNOWN_ELEMENT_TYPES.contains(elementType);
	}

	/**
	 * @generated
	 */
	public static IElementType getElementType(int visualID) {
		switch (visualID) {
		case ERDiagramEditPart.VISUAL_ID:
			return ERDiagram_1000;
		case RelationshipEditPart.VISUAL_ID:
			return Relationship_2001;
		case EntityEditPart.VISUAL_ID:
			return Entity_2002;
		case RelationshipToEditPart.VISUAL_ID:
			return RelationshipTo_4002;
		case RelationshipFromEditPart.VISUAL_ID:
			return RelationshipFrom_4001;
		}
		return null;
	}

}
